 #include <jni.h>
#include <string.h>
#include <stdio.h>
#include <android/log.h>

#define DEBUG_TAG "NDK_AndroidNDK1SampleActivity"

JavaVM *vm;
JNIEnv *env;
jclass manager_class;
jclass rsf_class;
jobject self;


jint JNI_OnLoad(JavaVM *curVM, void *reserved) {
	vm = curVM;
	__android_log_print(3, "[RSF]", "1");


	if((*vm)->GetEnv(vm, (void **)&env, JNI_VERSION_1_4) != JNI_OK)
		return -1;

	__android_log_print(3, "[RSF]", "2");
	return JNI_VERSION_1_4;
}


void Java_org_openfx_sample_ndk1_AndroidNDK1SampleActivity_helloLog(JNIEnv * env, jobject this, jstring logThis)
{
	jboolean isCopy;
	const char * szLogThis = (*env)->GetStringUTFChars(env, logThis, &isCopy);
	
	__android_log_print(ANDROID_LOG_DEBUG, DEBUG_TAG, "NDK:LC: [%s]", szLogThis);
	
	(*env)->ReleaseStringUTFChars(env, logThis, szLogThis);
}

jstring Java_org_openfx_sample_ndk1_AndroidNDK1SampleActivity_getString(JNIEnv * env, jobject this, jint value1, jint value2)
{
	char *szFormat = "The sum of the two numbers is: %i";
	char *szResult;
	
	// add the two values
	jlong sum = value1+value2;
	
	// malloc room for the resulting string
	szResult = malloc(sizeof(szFormat) + 20);
	
	// standard sprintf
	sprintf(szResult, szFormat, sum);
	
	// get an object string
	jstring result = (*env)->NewStringUTF(env, szResult);
	
	// cleanup 
	free(szResult);
	
	return result;
}


void Java_org_openfx_sample_ndk1_AndroidNDK1SampleActivity_setup(JNIEnv * env, jobject this){
	int id=10;
	__android_log_print(3, "HELLO", "calling INIT");

	// calling instance method
	manager_class = (*env)->FindClass(env, "org/openfx/sample/ndk1/AndroidNDK1SampleActivity");  // This works
   //	rsf_class = (*env)->FindClass(env, "com/mamlambo/sample/ndk1/CRsf2");  // This does not work - fails immediately
	if(manager_class == NULL){
		__android_log_print(3, "[haptimap]", "Cound not find class");
		return;
	}
    if ((*env)->ExceptionCheck(env)) {
		__android_log_print(3, "[haptimap]", "Exception occured!");
		(*env)->ExceptionDescribe(env);
	}
	__android_log_print(3, "HELLO", "calling INIT 2");
	jmethodID mid = (*env)->GetMethodID(env,  manager_class, "onRSF", "(I)I");  // check Native spec for Type Signatures 
    if (mid == NULL) {
		__android_log_print(3, "[haptimap]", "Cound not find method");
		return;
	}
	__android_log_print(3, "HELLO", "calling INIT 3");
	id = (*env)->CallIntMethod(env, this, mid, id);
	__android_log_print(ANDROID_LOG_DEBUG, DEBUG_TAG, "NDK:Return Value [%d]", id);

	
	///////////  calling class static method

    rsf_class = (*env)->FindClass(env, "org/openfx/sample/rsf1/CRsf");  /// calling this class does not work ???
	if(rsf_class == NULL){
		__android_log_print(3, "[haptimap]", "Cound not find class");
		return;
	}
	jmethodID mids = (*env)->GetStaticMethodID(env,  rsf_class, "onRSF", "(I)I");  // check Native spec for Type Signatures 
    if (mids == NULL) {
		__android_log_print(3, "[haptimap]", "Cound not find method");
		return;
	}
	id = (*env)->CallStaticIntMethod(env, rsf_class, mids, id);
}

